# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# GDevelop_is1       GDevelop version 4.0        4.0         "C:\Program Files (x86)\GDevelop\unins000.exe"

# Declaring specific app values (TO CHANGE)
bin_name_string = "gdevelop-setup-%s.exe"
bin_name_joker = "gdevelop-setup-*.exe"
silent_arguments = "/VERYSILENT /SUPPRESSMSGBOXES /NORESTART /SP-"
uninstall_key = "GDevelop_is1"


def install():
    print("installing gdevelop")

    # Declaring specific app values
    package_version = control["version"].split("-", 1)[0]
    impacted_process = control["impacted_process"]

    install_exe_if_needed(
        bin_name_string % package_version, silentflags=silent_arguments, key=uninstall_key, min_version="4.0", killbefore=impacted_process
    )


def update_package():
    import bs4 as BeautifulSoup
    import requests, re

    # Declaring specific app values
    app_name = control["name"]
    url = control["sources"]

    # Get Proxy informations from WAPT settings
    proxies = {}
    if isfile(makepath(application_data(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"), "global", "http_proxy")
        if proxywapt:
            proxies = {"http": proxywapt, "https": proxywapt}

    verify = True
    current_version = control.version.split("-", 1)[0]

    # Get version number from official website
    page = requests.get(url, headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64)"}, verify=verify).text
    bs = BeautifulSoup.BeautifulSoup(page)
    bs_raw_string = str(bs.find("span", {"class": "css-truncate-target"}).text)
    version = bs_raw_string.strip()
    print(app_name + " version is: " + version)

    # Declaring binaries extension to download
    reg_bin = "(\.exe|\.msi)$"  # $ mean the end of regex chain
    end_bin = re.compile(reg_bin)

    links = bs.findAll("a", {"href": end_bin})
    part_url_dl = links[0]["href"]
    # print(part_url_dl)

    url_dl = "https://github.com" + part_url_dl
    print("Download url is: " + url_dl)

    latest_bin = bin_name_string % version

    # Deleting outdated binaries
    for actual_bin in glob.glob(bin_name_joker):
        if actual_bin != latest_bin:
            print(actual_bin + " Deleted")
            remove_file(actual_bin)

    # Downloading latest binaires
    if not isfile(latest_bin):
        print("Downloading " + url_dl)
        wget(url_dl, latest_bin, proxies=proxies)

        control.version = version + "-0"
        control.save_control_to_wapt(os.getcwd())
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")
